local iconGold = GOLD_AMOUNT_TEXTURE
local iconSilver = SILVER_AMOUNT_TEXTURE
local iconCopper = COPPER_AMOUNT_TEXTURE

local Addon = {}
Addon.name = "Broker_AuctionsToGo"
_, Addon.title, Addon.notes = GetAddOnInfo(Addon.name)
Addon.version = GetAddOnMetadata(Addon.name, "Version")
Addon.brokername = GetAddOnMetadata(Addon.name, "X-BrokerName")
Addon.dbversion = "0.1"

local AuctionsToGo = LibStub( "AceAddon-3.0" ):NewAddon( Addon.name, "AceEvent-3.0" )
local broker = LibStub("LibDataBroker-1.1", true)
local LibQTip = LibStub('LibQTip-1.0')
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigReg = LibStub("AceConfigRegistry-3.0")
-- local L = LibStub("AceLocale-3.0"):GetLocale("Broker_SysMon")


AuctionsToGo.frame = CreateFrame("Frame")
local tooltip

local myauctions = {}
local player = {}
local ldb_text_string = "Current Auctions (me/realm): %d/%d"
local texture_format = "\124T%s:%d:%d:%d:%d\124t%s"
local auctime = { "short", "medium", "long", "very long" }
local colors = {
	black = "|c00000000",
	blue = "|c000000ff",
	green = "|cff00ff00",
	red = "|cffff0000", 
	white = "|cffffffff",
	yellow = "|cffffff00",
	none = "|r",
}

function AuctionsToGo:Colorize(text, color) 
	return (colors[color] .. text .. colors["none"])
end

function AuctionsToGo:Print(text)
	local _, font = DEFAULT_CHAT_FRAME:GetFont()

	font = math.ceil(font)
	if (text) then
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(AuctionsToGo:Colorize("Broker:", "yellow") .. AuctionsToGo:Colorize("AuctionsToGo - ", "red") .. text, 1, 1, 1)
		end
	end
end

function AuctionsToGo:PrintDebug(text)
	if (AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.debug) then
		AuctionsToGo:Print("DEBUG: " .. text)
	end
end

function AuctionsToGo:GetPlayerNames()
        local index = 1
        for charname, _ in pairs(AuctionsToGo.db.factionrealm) do
		AuctionsToGo:PrintDebug("Index: " .. index .. " Player: " .. charname)
                player[index] = charname
                index = index + 1
        end

	-- If table decreased, cut off the end
        for i = # player, index, -1 do
                player[i] = nil
        end

        return player
end


AuctionsToGo.ldb = broker:NewDataObject(Addon.name, {
	suffix = "auctions",
	label = "AuctionsToGo",
	type = "data source",
	OnClick = function(frame, button)
		if (button == "RightButton") then
			local dbfr = AuctionsToGo.db.factionrealm[AuctionsToGo.me]
			local dbr = AuctionsToGo.db.realm
			if (IsShiftKeyDown()) then
				dbfr.auctioncount = 0
				dbr.auctioncount = 0
				dbr.buyoutSum = 0

				local db = AuctionsToGo.db.factionrealm
				for charname,char in pairs(db) do
					char.auctions = nil
					char.buyoutSum = 0
				end
			else
				if ( dbr.auctioncount >= dbfr.auctioncount) then
					dbr.auctioncount = dbr.auctioncount - dbfr.auctioncount
				end
				if (dbr.buyoutSum >= dbfr.buyoutSum) then
					dbr.buyoutSum = dbr.buyoutSum - dbfr.buyoutSum
				end
				AuctionsToGo.db.factionrealm[AuctionsToGo.me] = {}
			end
		elseif (button == "LeftButton") then
			InterfaceOptionsFrame_OpenToCategory(AuctionsToGo.menu)
		end
	end,
	OnEnter = function(self)
		local db = AuctionsToGo.db.factionrealm

		tooltip = LibQTip:Acquire( Addon.name, 1, "LEFT")
		self.tooltip = tooltip
		tooltip:SetScale(AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.tooltipscale)
		tooltip:Clear()
		tooltip:AddLine(AuctionsToGo:Colorize("Auctions To Go", "yellow"))
		tooltip:AddLine(" ")

		local limited = AuctionsToGo:Colorize("unlimited", "yellow")
		if (db[AuctionsToGo.me].options.display.maxauctions >= 0) then
			limited = AuctionsToGo:Colorize("limited to ", "yellow") .. AuctionsToGo:Colorize(db[AuctionsToGo.me].options.display.maxauctions, "red") .. AuctionsToGo:Colorize(" Auctions", "yellow")
		end
		tooltip:AddLine(AuctionsToGo:Colorize("Output ", "yellow") .. limited)

		for charname,char in pairs(db) do
			AuctionsToGo:PrintDebug(charname)
			if (db[AuctionsToGo.me].options.display.shownchar[charname] and char.auctions ~= nil and next(char.auctions) ~= nil) then
				tooltip:SetColumnLayout(5, "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT")
				tooltip:AddLine("Auctions  - " .. AuctionsToGo:Colorize(charname, "green"))
				tooltip:SetColumnLayout(5, "LEFT", "RIGHT", "RIGHT", "RIGHT", "RIGHT")

				local auctioncounter = 0
				if (# char.auctions > 0 and db[AuctionsToGo.me].options.display.maxauctions ~= 0 ) then
					tooltip:AddHeader("Item", "Current Bid", "Minumum bid", "Buy Out", "Run Time")
					for i,v in ipairs(char.auctions) do
						local minbidstringstring, timeleftstring
						if (v.saleStatus == 1) then
							minbidstringstring = "sold"
							timeleftstring = "none"
						else
							minbidstringstring = AuctionsToGo:CreateMoneyString(v.minBid)
							timeleftstring = auctime[v.timeLeft]
						end
						tooltip:AddLine(string.format(texture_format,v.texture, 24,24,1,0, v.link .. "x" .. v.count),  AuctionsToGo:CreateMoneyString(v.bidAmount), minbidstringstring, AuctionsToGo:CreateMoneyString(v.buyoutPrice), timeleftstring)
						if (db[AuctionsToGo.me].options.display.maxauctions > 0) then
							auctioncounter = auctioncounter + 1
							if (auctioncounter >= db[AuctionsToGo.me].options.display.maxauctions) then
								break
							end
						end
					end
					if (char.buyoutSum) then
						tooltip:SetColumnLayout(5, "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT")
						tooltip:AddLine(AuctionsToGo:Colorize("Totals", "red") .. " - " .. AuctionsToGo:Colorize(charname, "green") .. ":"," "," ",AuctionsToGo:CreateMoneyString(char.buyoutSum))
					end
					tooltip:AddLine(" ")
				end
			end
		end
		if (AuctionsToGo.db.realm.buyoutSum) then
			tooltip:AddLine(" ")
			tooltip:AddLine(AuctionsToGo:Colorize("Totals:", "red")," "," ", AuctionsToGo:CreateMoneyString(AuctionsToGo.db.realm.buyoutSum))
		end

		tooltip:SetColumnLayout(1, "RIGHT")
		tooltip:AddLine(" ")
		tooltip:AddLine(AuctionsToGo:Colorize("Left click to open configuration menu.", "yellow") .. " " .. AuctionsToGo:Colorize("Right click to reset your character's information!", "yellow"))

		tooltip:EnableMouse()
		tooltip:SmartAnchorTo(self)
		tooltip:Show()
	end,
	OnLeave = function(self)
		LibQTip:Release(self.tooltip)
		self.tooltip = nil
	end,

})

function AuctionsToGo:CreateMoneyString(money)
	local moneystring = {}

	if (money == 0) then
		return 0
	end

	local copper = money % 100
	money = (money - copper) / 100
	local silver = money % 100
	local gold = floor(money / 100)

	if (gold > 0) then
		moneystring[# moneystring +1] = string.format(iconGold, gold, 16, 16)
		moneystring[# moneystring +1] = " "
	end

	if (gold + silver > 0) then
		moneystring[# moneystring +1] = string.format(iconGold, silver, 16, 16)
		moneystring[# moneystring +1] = " "
	end

	if (gold + silver + copper > 0) then
		moneystring[# moneystring +1] = string.format(iconGold, copper, 16, 16)
		moneystring[# moneystring +1] = " "
	end

	return table.concat(moneystring)
end

AuctionsToGo.optionsTable = {
	type = "group",
	name = Addon.name,
	childGroups = "tree",
	args = {
		header1 = {
			type = "description",
			order = 5,
			name = Addon.brokername,
			cmdHidden = true,
		},
		header2 = {
			type = "description",
			order = 10,
			name = Addon.notes,
			cmdHidden = true,
		},
		header2 = {
			type = "description",
			order = 15,
			name = "Version: " .. Addon.version,
			cmdHidden = true,
		},
		generalConfig = {
			type = "group",
			name = "General",
			order = 50,
			inline = true,
			childGroups = "tree",
			args = {
				debugswitch = {
					type = "toggle",
					name = "Debugging",
					desc = "En/disable debugging output",
					get = function() return AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.debug end,
					set = function(i, newvalue)
						AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.debug = newvalue
					end,
				},
			},
		},
		tooltipDisplay = {
			type = "group",
			name = "Tooltip",
			order = 100,
			inline = true,
			childGroups = "tree",
			args = {
				tooltipscaling = {
					type = "range",
					order = 10,
					name = "Tooltip Scale",
					desc = "Change tooltip scaling",
					min = 0.5,
					max = 1.5,
					step = 0.05,
					bigStep = 0.1,
					get = function() return AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.tooltipscale end,
					set = function(i, newvalue)
						AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.tooltipscale = newvalue
						tooltip:SetScale(newvalue)
					end,
				},
				maxShowAuction = {
					type = "range",
					order = 15,
					name = "Maximum Auctions",
					desc = "How many auctions to show - -1 shows all",
					min = -1,
					max = 200,
					step = 1,
					bigStep = 10,
					get = function() return AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.maxauctions end,
					set = function(i, newvalue)
						AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.maxauctions = newvalue
					end,
				},
				shownChars = {
					type = "multiselect",
					order = 30,
					name = "Show which Characters in tooltip",
					values = player,
					get = function(info, key)
						AuctionsToGo:PrintDebug("multiselect get - key: " .. key)
						return AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.shownchar[player[key]]
					end,
					set = function(info, key, newvalue)
						AuctionsToGo.db.factionrealm[AuctionsToGo.me].options.display.shownchar[player[key]] = newvalue
					end,
				},
			},
		},
	},
}

function AuctionsToGo:UpgradeDB()
	local db = self.db.factionrealm[AuctionsToGo.me]

	if (not db.options.dbversion) then
		if (db.options.tooltipscale) then
			db.options.display.tooltipscale = db.options.tooltipscale
			db.options.tooltipscale = nil
		else
			if (not db.options.display.tooltipscale) then
				db.options.display.tooltipscale = 1
			end
		end

		if (db.options.maxauctions) then
			db.options.display.maxauctions = db.options.maxauctions
			db.options.maxauctions = nil
		else
			if (not db.options.display.maxauctions) then
				db.options.display.maxauctions = -1
			end
		end
		if (not db.options.debug) then
			db.options.debug = false
		end
		if (db.options.shownchar) then
			db.options.display.shownchar = db.options.shownchar
			db.options.shownchar = nil
		else
			if (not db.options.display.shownchar) then
				db.options.display.shownchar = {}
				for i, charname in pairs(player) do
					db.options.display.shownchar[charname] = true
				end
			end
		end
		db.options.dbversion = "0.1"
		AuctionsToGo:Print("Database updated to: 0.1")
	end
end


function AuctionsToGo:OnEnable()
	-- Called when the addon is loaded
	self.db = LibStub( "AceDB-3.0" ):New( "BATG_DB", nil, "Default" )
	if ( not self.db.factionrealm) then
		self.db.factionrealm = {}
	end

	if (not self.db.realm.auctioncount) then
		self.db.realm.auctioncount = 0
	end

	if (not self.db.realm.buyoutSum) then
		self.db.realm.buyoutSum = 0
	end

	AuctionsToGo.me = UnitName( "player" )
	AuctionsToGo.realm = GetRealmName()
	player = AuctionsToGo:GetPlayerNames()
	table.sort(player)

	AuctionsToGo:PrintDebug("Player-Array[1]: " .. player[1])

	-- do we have any data yet for this toon? If not, init its table
	if not ( self.db.factionrealm[AuctionsToGo.me] ) then
		self.db.factionrealm[AuctionsToGo.me] = {
			auctions = {},
			options = {
				dbversion = Addon.dbversion,
				debug = false,
				display = {
					tooltipscale = 1,
					maxauctions = -1,
					shownchar = {},
				},
			},
		}
		for i, charname in pairs(player) do
			self.db.factionrealm[AuctionsToGo.me].options.display.shownchar[charname] = true
		end
	end

	if (not self.db.factionrealm[AuctionsToGo.me].options.dbversion or self.db.factionrealm[AuctionsToGo.me].options.dbversion ~= Addon.dbversion) then
		AuctionsToGo:UpgradeDB()
	end

	local brokerOptions = AceConfigReg:GetOptionsTable("Broker", "dialog", "LibDataBroker-1.1")
	if (not brokerOptions) then
		brokerOptions = {
			type = "group",
			name = "Broker",
			args = {
			}
		}
		AceConfigReg:RegisterOptionsTable("Broker", brokerOptions)
		LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker", "Broker")
	end

	AceConfigReg:RegisterOptionsTable(Addon.name, AuctionsToGo.optionsTable)
	AuctionsToGo.menu = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(Addon.name, Addon.brokername, "Broker")

end

function AuctionsToGo:AUCTION_OWNED_LIST_UPDATE(eventname, ...)
	local dbfr = self.db.factionrealm[AuctionsToGo.me]
	local dbr = self.db.realm

	if ( dbfr.auctioncount) then
		if (dbr.auctioncount >= dbfr.auctioncount ) then
			dbr.auctioncount = dbr.auctioncount - dbfr.auctioncount
		end
	end

	if (dbfr.buyoutSum and dbr.buyoutSum >= dbfr.buyoutSum ) then
		dbr.buyoutSum = dbr.buyoutSum - dbfr.buyoutSum
	end
	dbfr.buyoutSum = 0


	_, dbfr.auctioncount = GetNumAuctionItems("owner")
	dbr.auctioncount = dbr.auctioncount + dbfr.auctioncount

	dbfr.auctions = {}

	AuctionsToGo.ldb.text = string.format(ldb_text_string, dbfr.auctioncount, dbr.auctioncount)

	for i=1,dbfr.auctioncount do
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("owner", i);
		local link = GetAuctionItemLink("owner", i);
		local timeLeft = GetAuctionItemTimeLeft("owner", i);
		dbfr.auctions[i] = {
			name = name,
			texture = texture,
			count = count,
			quality = quality,
			canUse = canUse,
			level = level,
			minBid = minBid,
			minIncrement = minIncrement,
			buyoutPrice = buyoutPrice,
			bidAmount = bidAmount,
			highBidder = highBidder,
			owner = owner,
			saleStatus = saleStatus,
			link = link,
			timeLeft = timeLeft,
		}
		dbfr.buyoutSum = dbfr.buyoutSum + buyoutPrice
	end
	dbr.buyoutSum = dbr.buyoutSum + dbfr.buyoutSum
end

local total = 0
AuctionsToGo.frame:SetScript("OnUpdate", function(self, elapsed)
	total = total + elapsed
	if total < 1 then return end
	total = 0

	local dbr_count, dbfr_count = 0, 0
	if (AuctionsToGo.db.factionrealm[AuctionsToGo.me].auctioncount) then
		dbfr_count = AuctionsToGo.db.factionrealm[AuctionsToGo.me].auctioncount
	end
	if (AuctionsToGo.db.realm.auctioncount) then
		dbr_count = AuctionsToGo.db.realm.auctioncount
	end

	AuctionsToGo.ldb.text = string.format(ldb_text_string, dbfr_count, dbr_count)
end)

AuctionsToGo:RegisterEvent("AUCTION_OWNED_LIST_UPDATE")
